﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Inherits="_Default" %>

<%@ Register Assembly="Telerik.Web.UI" Namespace="Telerik.Web.UI" TagPrefix="telerik" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Untitled Page</title>
</head>
<body>
    <script type="text/javascript">
        var editedNode = null;
        var treeView = null;
        
        function pageLoad()
        {
            treeView = $find("<%= RadTreeView1.ClientID %>");
        }
        
        function onKeyDown(e)
        {
            if ( ! editedNode)
            {
                return;
            }
            
            if (!e)
            {
                e = event;
            }
            
            if (e.keyCode == 13)
            {
                endEditNode();
                
                return;
            }
            
            if ( ! e.altKey)
            {
                return;
            }
            
            var keyCode = e.keyCode;

            var nextNodeToEdit = null;

            switch (keyCode)
            {
                case 40:
                    nextNodeToEdit = editedNode.get_nextNode();
                    break;
                case 38:
                    nextNodeToEdit = editedNode.get_previousNode();
                    break;
                case 37:
                    var parent = editedNode.get_parent();
                    
                    if (parent != treeView)
                    {
                        nextNodeToEdit = parent;
                    }
                    break;
                case 39:
                    var childNodes = editedNode.get_nodes();
                    
                    if (childNodes.get_count() > 0)
                    {
                        editedNode.expand();
                    
                        nextNodeToEdit = childNodes.getNode(0);
                    }
                    break;
                default:
                    break;
            }
            
            if (nextNodeToEdit)
            {
                endEditNode();
                
                nextNodeToEdit.select();
                
                startEditNode(nextNodeToEdit);
            }
        }
        
        function clientNodeClicked(sender, eventArgs)
        {
            var node = eventArgs.get_node();
            
            startEditNode(node);
        }
        
        function startEditNode(node)
        {
            treeView.trackChanges();
            
            node.startEdit();
            
            editedNode = node;
            
            var nodeElement = node.get_element();
            
            var inputs = nodeElement.getElementsByTagName("INPUT");
            
            if (inputs && inputs[0])
            {
                inputs[0].onkeydown = onKeyDown;
            }
        }
        
        function endEditNode()
        {
            editedNode._endEdit(false);
                
            treeView.commitChanges();
        }
    </script>
    <form id="form1" runat="server">
        <asp:ScriptManager ID="ScriptManager1" runat="server" />
        <div>
            <telerik:RadTreeView ID="RadTreeView1" runat="server" AllowNodeEditing="True" AccessKey="W" TabIndex="1"
                OnClientNodeClicked="clientNodeClicked">
            <Nodes>
                <telerik:RadTreeNode runat="server" Text="Root RadTreeNode1">
                </telerik:RadTreeNode>
                <telerik:RadTreeNode runat="server" Text="Root RadTreeNode2">
                    <Nodes>
                        <telerik:RadTreeNode runat="server" Text="Child RadTreeNode 1">
                            <Nodes>
                                <telerik:RadTreeNode runat="server" Text="Child RadTreeNode 1">
                                </telerik:RadTreeNode>
                            </Nodes>
                        </telerik:RadTreeNode>
                        <telerik:RadTreeNode runat="server" Text="Child RadTreeNode 2">
                        </telerik:RadTreeNode>
                    </Nodes>
                </telerik:RadTreeNode>
                <telerik:RadTreeNode runat="server" Text="Root RadTreeNode3">
                </telerik:RadTreeNode>
            </Nodes>
            <CollapseAnimation Duration="100" Type="OutQuint" />
            <ExpandAnimation Duration="100" />
        </telerik:RadTreeView>
        <asp:Button ID="Button1" runat="server" Text="Check Persistence" />
        </div>
    </form>
</body>
</html>